'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Класс для работы с токенами.
 */
var TokenHelper = function () {
    function TokenHelper() {
        _classCallCheck(this, TokenHelper);
    }

    _createClass(TokenHelper, [{
        key: 'setToken',

        /**
         * Установка токенов.
         *
         * @param {string} access_token
         * @param {int} expires_in
         * @param token_type
         * @param {string} refresh_token
         */
        value: function setToken(access_token, expires_in) {
            var token_type = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'Bearer';
            var refresh_token = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : undefined;


            if (access_token === undefined || access_token.length < 1) {
                console.warn('\u0412\u043D\u0438\u043C\u0430\u043D\u0438\u0435! \u041D\u0435 \u0443\u0434\u0430\u043B\u043E\u0441\u044C \u0443\u0441\u0442\u0430\u043D\u043E\u0432\u0438\u0442\u044C \u0442\u043E\u043A\u0435\u043D: ' + access_token + ', \u0442.\u043A. \u043E\u043D \u043D\u0435 \u0437\u0430\u0434\u0430\u043D \u0438\u043B\u0438 \u043F\u0443\u0441\u0442!');
                return false;
            }

            localStorage.setItem('access_token', access_token);

            localStorage.setItem('token_type', token_type);

            if (expires_in !== undefined) {
                localStorage.setItem('expires_in', expires_in + new Date());
            }

            if (refresh_token !== undefined) {
                localStorage.setItem('refresh_token', refresh_token);
            }

            return true;
        }

        /**
         * Проверить авторизованность (наличие установленного токена и время его жизни).
         */

    }, {
        key: 'isAuthenticated',
        value: function isAuthenticated() {
            !TokenHelper.tokenWasExpired() && this.getToken();
        }

        /**
         * Получить токен доступа.
         */

    }, {
        key: 'getToken',
        value: function getToken() {
            localStorage.getItem('access_token');
        }

        /**
         * Проверить, истекло ли время жизни токена.
         */

    }], [{
        key: 'tokenWasExpired',
        value: function tokenWasExpired() {
            var expires_in = localStorage.getItem('expires_in');

            return !expires_in ? false : new Date() >= expires_in;
        }

        /**
         * Удалить токены из хранилища.
         */

    }, {
        key: 'removeTokens',
        value: function removeTokens() {
            localStorage.removeItem('access_token');
            localStorage.removeItem('expires_in');
            localStorage.removeItem('refresh_token');
            localStorage.removeItem('token_type');
        }
    }]);

    return TokenHelper;
}();

exports.default = TokenHelper;